using C1.Win.FlexGrid;
using C1.Win.Input;
using System.Collections;

namespace FlexGrid_DropDown
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            var mapCol = c1FlexGrid1.Cols[1];
            mapCol.Name = mapCol.Caption = "DataMap";
            var p_DataMap = new Dictionary<int, string>();

            int i = 0;

            while(i<6000)
            {
                //Dictionary<int, string> dic = new Dictionary<int, string>();
                p_DataMap.Add(i, String.Format("Item {0}", i.ToString()));
                i++;
                p_DataMap.Add(i, String.Format("Element {0}", i.ToString()));
                i++;
            }

            SetFieldDataMap(c1FlexGrid1, mapCol.Name, p_DataMap);
        }

        public void SetFieldDataMap(C1FlexGrid p_flx, string p_sFieldName, IDictionary p_DataMap)
        {
            CellRange range = p_flx.GetCellRange(1, 1);
            var _combo = new C1ComboBox()
            {
                ItemsDataSource = p_DataMap,
                ItemsValueMember = "Key",
                ItemsDisplayMember = "Value",

                //Set TranslateValue to true, so that ComboBox shows the DisplayMember
                TranslateValue = true,
                AutoCompleteMode = AutoCompleteMode.Suggest,
                AutoCompleteSource = AutoCompleteSource.ListItems
            };
            range.StyleNew.Editor = _combo;

            //cell/column must have a DataType set for the datamap to work
            range.StyleNew.DataType = typeof(int);
            //set the datamap along with Editor to show mapped values
            range.StyleNew.DataMap = p_DataMap;
        }
    }
}
